﻿Option Explicit On

Public Class Form1


Const contrast = 6
Const gain = 6
Const SampleRate = 48000
Const bins = 2048

Dim N As Short        'Number of points in the DFT,
Dim REX() As Double     'Real part of input
Dim IMX() As Double     'Imaginary part of input
Dim ln As Single        'Vertical line # in Waterfall
Dim Volume As Double
Dim curSample As Integer

Dim brightness As Short

Dim scet As Integer


Dim fError As Boolean






Private Sub Command1_Click() Handles Command1.Click
 Command1.Enabled = True
   Command2.Enabled = False
End Sub

Private Sub Command2_Click() Handles Command2.Click
Command1.Enabled = False
Command2.Enabled = True
End Sub

Private Sub Form_Activate() Handles MyBase.Activated

    N = 2048   'Number of samples must be  2^k  where k = integer > 1
    BUFFER_SIZE = 4096      'Must be at least 2 * max number of bins

    ReDim REX(N - 1)
    ReDim IMX(N - 1)

    CmdSwitch.Text = "Start"

    lblBrightness.Text = "Brightness " + Str(scrBrightness.Value)
    brightness = scrBrightness.Value

    ln = 0  'Waterfall must start at line 0

    Timer1.Interval = 1
    Timer1.Enabled = True



End Sub


Private Sub CmdSwitch_Click() Handles CmdSwitch.Click
    If CmdSwitch.Text = "Start" Then
        CmdSwitch.Text = "Freeze"
        StartInput()
    Else
        CmdSwitch.Text = "Start"
        StopInput()
    End If

End Sub



Private Sub scrBrightness_Change() Handles scrBrightness.ValueChanged
    lblBrightness.Text = "Brightness " + Str(scrBrightness.Value)
    brightness = scrBrightness.Value
End Sub

Private Sub Timer1_Timer() Handles Timer1.Tick  ' Process sound buffer if recording

    If (fRecording) Then
        If inHdr.dwFlags And WHDR_DONE Then
            rc = waveInAddBuffer(hWaveIn, inHdr, Len(inHdr))
            DrawSpectrum()
        End If

    End If

End Sub

Private Sub Form_QueryUnload() Handles MyBase.FormClosing
    If (fRecording) Then
        StopInput()
    End If
End Sub

 Sub DrawSpectrum()

    'Dim Volume As Double
        'Dim curSample As Single
        Dim f As Integer, kk As Double
    N = 2048


        For sample = 0 To 2047
            GetMono16Sample(sample, Volume)
            REX(sample) = Volume

            IMX(sample) = 0
        Next

    FFT(N, REX, IMX)


    For f = 0 To 1024
            kk = (Math.Sqrt(REX(f) ^ 2) * 100) + Int(brightness)
        If kk < 1 Then
            kk = 1
        End If
        kk = gain * Math.Log(kk)


    Next
    If kk > 16 Then 'StopInput

           scet = scet + 1
          Command1_Click()
          Command1.Text = CStr(scet)
          'Else
          'Command2_Click

        End If
        Text1.Text = CStr(kk)
End Sub
End Class
